# /* **************************************************************************
#  *                                                                          *
#  *     (C) Copyright Paul Mensonides 2002.
#  *     Distributed under the Boost Software License, Version 1.0. (See
#  *     accompanying file LICENSE_1_0.txt or copy at
#  *     http://www.boost.org/LICENSE_1_0.txt)
#  *                                                                          *
#  ************************************************************************** */
#
# /* Revised by Edward Diener (2020) */
#
# /* See http://www.boost.org for most recent version. */
#
# include <gridtools/preprocessor/config/config.hpp>
#
# if ~GT_PP_CONFIG_FLAGS() & GT_PP_CONFIG_STRICT()
#
# if GT_PP_CONFIG_FLAGS() & GT_PP_CONFIG_DMC()
#     include <gridtools/preprocessor/detail/dmc/auto_rec.hpp>
# else
#
# ifndef GT_PREPROCESSOR_DETAIL_AUTO_REC_HPP
# define GT_PREPROCESSOR_DETAIL_AUTO_REC_HPP
#
# include <gridtools/preprocessor/control/iif.hpp>
#
# /* GT_PP_AUTO_REC */
#
# define GT_PP_AUTO_REC(pred, n) GT_PP_NODE_ENTRY_ ## n(pred)
#
# define GT_PP_NODE_ENTRY_256(p) GT_PP_NODE_128(p)(p)(p)(p)(p)(p)(p)(p)
# define GT_PP_NODE_ENTRY_128(p) GT_PP_NODE_64(p)(p)(p)(p)(p)(p)(p)
# define GT_PP_NODE_ENTRY_64(p) GT_PP_NODE_32(p)(p)(p)(p)(p)(p)
# define GT_PP_NODE_ENTRY_32(p) GT_PP_NODE_16(p)(p)(p)(p)(p)
# define GT_PP_NODE_ENTRY_16(p) GT_PP_NODE_8(p)(p)(p)(p)
# define GT_PP_NODE_ENTRY_8(p) GT_PP_NODE_4(p)(p)(p)
# define GT_PP_NODE_ENTRY_4(p) GT_PP_NODE_2(p)(p)
# define GT_PP_NODE_ENTRY_2(p) GT_PP_NODE_1(p)
#
# define GT_PP_NODE_128(p) GT_PP_IIF(p(128), GT_PP_NODE_64, GT_PP_NODE_192)
#    define GT_PP_NODE_64(p) GT_PP_IIF(p(64), GT_PP_NODE_32, GT_PP_NODE_96)
#        define GT_PP_NODE_32(p) GT_PP_IIF(p(32), GT_PP_NODE_16, GT_PP_NODE_48)
#            define GT_PP_NODE_16(p) GT_PP_IIF(p(16), GT_PP_NODE_8, GT_PP_NODE_24)
#                define GT_PP_NODE_8(p) GT_PP_IIF(p(8), GT_PP_NODE_4, GT_PP_NODE_12)
#                    define GT_PP_NODE_4(p) GT_PP_IIF(p(4), GT_PP_NODE_2, GT_PP_NODE_6)
#                        define GT_PP_NODE_2(p) GT_PP_IIF(p(2), GT_PP_NODE_1, GT_PP_NODE_3)
#                            define GT_PP_NODE_1(p) GT_PP_IIF(p(1), 1, 2)
#                            define GT_PP_NODE_3(p) GT_PP_IIF(p(3), 3, 4)
#                        define GT_PP_NODE_6(p) GT_PP_IIF(p(6), GT_PP_NODE_5, GT_PP_NODE_7)
#                            define GT_PP_NODE_5(p) GT_PP_IIF(p(5), 5, 6)
#                            define GT_PP_NODE_7(p) GT_PP_IIF(p(7), 7, 8)
#                    define GT_PP_NODE_12(p) GT_PP_IIF(p(12), GT_PP_NODE_10, GT_PP_NODE_14)
#                        define GT_PP_NODE_10(p) GT_PP_IIF(p(10), GT_PP_NODE_9, GT_PP_NODE_11)
#                            define GT_PP_NODE_9(p) GT_PP_IIF(p(9), 9, 10)
#                            define GT_PP_NODE_11(p) GT_PP_IIF(p(11), 11, 12)
#                        define GT_PP_NODE_14(p) GT_PP_IIF(p(14), GT_PP_NODE_13, GT_PP_NODE_15)
#                            define GT_PP_NODE_13(p) GT_PP_IIF(p(13), 13, 14)
#                            define GT_PP_NODE_15(p) GT_PP_IIF(p(15), 15, 16)
#                define GT_PP_NODE_24(p) GT_PP_IIF(p(24), GT_PP_NODE_20, GT_PP_NODE_28)
#                    define GT_PP_NODE_20(p) GT_PP_IIF(p(20), GT_PP_NODE_18, GT_PP_NODE_22)
#                        define GT_PP_NODE_18(p) GT_PP_IIF(p(18), GT_PP_NODE_17, GT_PP_NODE_19)
#                            define GT_PP_NODE_17(p) GT_PP_IIF(p(17), 17, 18)
#                            define GT_PP_NODE_19(p) GT_PP_IIF(p(19), 19, 20)
#                        define GT_PP_NODE_22(p) GT_PP_IIF(p(22), GT_PP_NODE_21, GT_PP_NODE_23)
#                            define GT_PP_NODE_21(p) GT_PP_IIF(p(21), 21, 22)
#                            define GT_PP_NODE_23(p) GT_PP_IIF(p(23), 23, 24)
#                    define GT_PP_NODE_28(p) GT_PP_IIF(p(28), GT_PP_NODE_26, GT_PP_NODE_30)
#                        define GT_PP_NODE_26(p) GT_PP_IIF(p(26), GT_PP_NODE_25, GT_PP_NODE_27)
#                            define GT_PP_NODE_25(p) GT_PP_IIF(p(25), 25, 26)
#                            define GT_PP_NODE_27(p) GT_PP_IIF(p(27), 27, 28)
#                        define GT_PP_NODE_30(p) GT_PP_IIF(p(30), GT_PP_NODE_29, GT_PP_NODE_31)
#                            define GT_PP_NODE_29(p) GT_PP_IIF(p(29), 29, 30)
#                            define GT_PP_NODE_31(p) GT_PP_IIF(p(31), 31, 32)
#            define GT_PP_NODE_48(p) GT_PP_IIF(p(48), GT_PP_NODE_40, GT_PP_NODE_56)
#                define GT_PP_NODE_40(p) GT_PP_IIF(p(40), GT_PP_NODE_36, GT_PP_NODE_44)
#                    define GT_PP_NODE_36(p) GT_PP_IIF(p(36), GT_PP_NODE_34, GT_PP_NODE_38)
#                        define GT_PP_NODE_34(p) GT_PP_IIF(p(34), GT_PP_NODE_33, GT_PP_NODE_35)
#                            define GT_PP_NODE_33(p) GT_PP_IIF(p(33), 33, 34)
#                            define GT_PP_NODE_35(p) GT_PP_IIF(p(35), 35, 36)
#                        define GT_PP_NODE_38(p) GT_PP_IIF(p(38), GT_PP_NODE_37, GT_PP_NODE_39)
#                            define GT_PP_NODE_37(p) GT_PP_IIF(p(37), 37, 38)
#                            define GT_PP_NODE_39(p) GT_PP_IIF(p(39), 39, 40)
#                    define GT_PP_NODE_44(p) GT_PP_IIF(p(44), GT_PP_NODE_42, GT_PP_NODE_46)
#                        define GT_PP_NODE_42(p) GT_PP_IIF(p(42), GT_PP_NODE_41, GT_PP_NODE_43)
#                            define GT_PP_NODE_41(p) GT_PP_IIF(p(41), 41, 42)
#                            define GT_PP_NODE_43(p) GT_PP_IIF(p(43), 43, 44)
#                        define GT_PP_NODE_46(p) GT_PP_IIF(p(46), GT_PP_NODE_45, GT_PP_NODE_47)
#                            define GT_PP_NODE_45(p) GT_PP_IIF(p(45), 45, 46)
#                            define GT_PP_NODE_47(p) GT_PP_IIF(p(47), 47, 48)
#                define GT_PP_NODE_56(p) GT_PP_IIF(p(56), GT_PP_NODE_52, GT_PP_NODE_60)
#                    define GT_PP_NODE_52(p) GT_PP_IIF(p(52), GT_PP_NODE_50, GT_PP_NODE_54)
#                        define GT_PP_NODE_50(p) GT_PP_IIF(p(50), GT_PP_NODE_49, GT_PP_NODE_51)
#                            define GT_PP_NODE_49(p) GT_PP_IIF(p(49), 49, 50)
#                            define GT_PP_NODE_51(p) GT_PP_IIF(p(51), 51, 52)
#                        define GT_PP_NODE_54(p) GT_PP_IIF(p(54), GT_PP_NODE_53, GT_PP_NODE_55)
#                            define GT_PP_NODE_53(p) GT_PP_IIF(p(53), 53, 54)
#                            define GT_PP_NODE_55(p) GT_PP_IIF(p(55), 55, 56)
#                    define GT_PP_NODE_60(p) GT_PP_IIF(p(60), GT_PP_NODE_58, GT_PP_NODE_62)
#                        define GT_PP_NODE_58(p) GT_PP_IIF(p(58), GT_PP_NODE_57, GT_PP_NODE_59)
#                            define GT_PP_NODE_57(p) GT_PP_IIF(p(57), 57, 58)
#                            define GT_PP_NODE_59(p) GT_PP_IIF(p(59), 59, 60)
#                        define GT_PP_NODE_62(p) GT_PP_IIF(p(62), GT_PP_NODE_61, GT_PP_NODE_63)
#                            define GT_PP_NODE_61(p) GT_PP_IIF(p(61), 61, 62)
#                            define GT_PP_NODE_63(p) GT_PP_IIF(p(63), 63, 64)
#        define GT_PP_NODE_96(p) GT_PP_IIF(p(96), GT_PP_NODE_80, GT_PP_NODE_112)
#            define GT_PP_NODE_80(p) GT_PP_IIF(p(80), GT_PP_NODE_72, GT_PP_NODE_88)
#                define GT_PP_NODE_72(p) GT_PP_IIF(p(72), GT_PP_NODE_68, GT_PP_NODE_76)
#                    define GT_PP_NODE_68(p) GT_PP_IIF(p(68), GT_PP_NODE_66, GT_PP_NODE_70)
#                        define GT_PP_NODE_66(p) GT_PP_IIF(p(66), GT_PP_NODE_65, GT_PP_NODE_67)
#                            define GT_PP_NODE_65(p) GT_PP_IIF(p(65), 65, 66)
#                            define GT_PP_NODE_67(p) GT_PP_IIF(p(67), 67, 68)
#                        define GT_PP_NODE_70(p) GT_PP_IIF(p(70), GT_PP_NODE_69, GT_PP_NODE_71)
#                            define GT_PP_NODE_69(p) GT_PP_IIF(p(69), 69, 70)
#                            define GT_PP_NODE_71(p) GT_PP_IIF(p(71), 71, 72)
#                    define GT_PP_NODE_76(p) GT_PP_IIF(p(76), GT_PP_NODE_74, GT_PP_NODE_78)
#                        define GT_PP_NODE_74(p) GT_PP_IIF(p(74), GT_PP_NODE_73, GT_PP_NODE_75)
#                            define GT_PP_NODE_73(p) GT_PP_IIF(p(73), 73, 74)
#                            define GT_PP_NODE_75(p) GT_PP_IIF(p(75), 75, 76)
#                        define GT_PP_NODE_78(p) GT_PP_IIF(p(78), GT_PP_NODE_77, GT_PP_NODE_79)
#                            define GT_PP_NODE_77(p) GT_PP_IIF(p(77), 77, 78)
#                            define GT_PP_NODE_79(p) GT_PP_IIF(p(79), 79, 80)
#                define GT_PP_NODE_88(p) GT_PP_IIF(p(88), GT_PP_NODE_84, GT_PP_NODE_92)
#                    define GT_PP_NODE_84(p) GT_PP_IIF(p(84), GT_PP_NODE_82, GT_PP_NODE_86)
#                        define GT_PP_NODE_82(p) GT_PP_IIF(p(82), GT_PP_NODE_81, GT_PP_NODE_83)
#                            define GT_PP_NODE_81(p) GT_PP_IIF(p(81), 81, 82)
#                            define GT_PP_NODE_83(p) GT_PP_IIF(p(83), 83, 84)
#                        define GT_PP_NODE_86(p) GT_PP_IIF(p(86), GT_PP_NODE_85, GT_PP_NODE_87)
#                            define GT_PP_NODE_85(p) GT_PP_IIF(p(85), 85, 86)
#                            define GT_PP_NODE_87(p) GT_PP_IIF(p(87), 87, 88)
#                    define GT_PP_NODE_92(p) GT_PP_IIF(p(92), GT_PP_NODE_90, GT_PP_NODE_94)
#                        define GT_PP_NODE_90(p) GT_PP_IIF(p(90), GT_PP_NODE_89, GT_PP_NODE_91)
#                            define GT_PP_NODE_89(p) GT_PP_IIF(p(89), 89, 90)
#                            define GT_PP_NODE_91(p) GT_PP_IIF(p(91), 91, 92)
#                        define GT_PP_NODE_94(p) GT_PP_IIF(p(94), GT_PP_NODE_93, GT_PP_NODE_95)
#                            define GT_PP_NODE_93(p) GT_PP_IIF(p(93), 93, 94)
#                            define GT_PP_NODE_95(p) GT_PP_IIF(p(95), 95, 96)
#            define GT_PP_NODE_112(p) GT_PP_IIF(p(112), GT_PP_NODE_104, GT_PP_NODE_120)
#                define GT_PP_NODE_104(p) GT_PP_IIF(p(104), GT_PP_NODE_100, GT_PP_NODE_108)
#                    define GT_PP_NODE_100(p) GT_PP_IIF(p(100), GT_PP_NODE_98, GT_PP_NODE_102)
#                        define GT_PP_NODE_98(p) GT_PP_IIF(p(98), GT_PP_NODE_97, GT_PP_NODE_99)
#                            define GT_PP_NODE_97(p) GT_PP_IIF(p(97), 97, 98)
#                            define GT_PP_NODE_99(p) GT_PP_IIF(p(99), 99, 100)
#                        define GT_PP_NODE_102(p) GT_PP_IIF(p(102), GT_PP_NODE_101, GT_PP_NODE_103)
#                            define GT_PP_NODE_101(p) GT_PP_IIF(p(101), 101, 102)
#                            define GT_PP_NODE_103(p) GT_PP_IIF(p(103), 103, 104)
#                    define GT_PP_NODE_108(p) GT_PP_IIF(p(108), GT_PP_NODE_106, GT_PP_NODE_110)
#                        define GT_PP_NODE_106(p) GT_PP_IIF(p(106), GT_PP_NODE_105, GT_PP_NODE_107)
#                            define GT_PP_NODE_105(p) GT_PP_IIF(p(105), 105, 106)
#                            define GT_PP_NODE_107(p) GT_PP_IIF(p(107), 107, 108)
#                        define GT_PP_NODE_110(p) GT_PP_IIF(p(110), GT_PP_NODE_109, GT_PP_NODE_111)
#                            define GT_PP_NODE_109(p) GT_PP_IIF(p(109), 109, 110)
#                            define GT_PP_NODE_111(p) GT_PP_IIF(p(111), 111, 112)
#                define GT_PP_NODE_120(p) GT_PP_IIF(p(120), GT_PP_NODE_116, GT_PP_NODE_124)
#                    define GT_PP_NODE_116(p) GT_PP_IIF(p(116), GT_PP_NODE_114, GT_PP_NODE_118)
#                        define GT_PP_NODE_114(p) GT_PP_IIF(p(114), GT_PP_NODE_113, GT_PP_NODE_115)
#                            define GT_PP_NODE_113(p) GT_PP_IIF(p(113), 113, 114)
#                            define GT_PP_NODE_115(p) GT_PP_IIF(p(115), 115, 116)
#                        define GT_PP_NODE_118(p) GT_PP_IIF(p(118), GT_PP_NODE_117, GT_PP_NODE_119)
#                            define GT_PP_NODE_117(p) GT_PP_IIF(p(117), 117, 118)
#                            define GT_PP_NODE_119(p) GT_PP_IIF(p(119), 119, 120)
#                    define GT_PP_NODE_124(p) GT_PP_IIF(p(124), GT_PP_NODE_122, GT_PP_NODE_126)
#                        define GT_PP_NODE_122(p) GT_PP_IIF(p(122), GT_PP_NODE_121, GT_PP_NODE_123)
#                            define GT_PP_NODE_121(p) GT_PP_IIF(p(121), 121, 122)
#                            define GT_PP_NODE_123(p) GT_PP_IIF(p(123), 123, 124)
#                        define GT_PP_NODE_126(p) GT_PP_IIF(p(126), GT_PP_NODE_125, GT_PP_NODE_127)
#                            define GT_PP_NODE_125(p) GT_PP_IIF(p(125), 125, 126)
#                            define GT_PP_NODE_127(p) GT_PP_IIF(p(127), 127, 128)
#    define GT_PP_NODE_192(p) GT_PP_IIF(p(192), GT_PP_NODE_160, GT_PP_NODE_224)
#        define GT_PP_NODE_160(p) GT_PP_IIF(p(160), GT_PP_NODE_144, GT_PP_NODE_176)
#            define GT_PP_NODE_144(p) GT_PP_IIF(p(144), GT_PP_NODE_136, GT_PP_NODE_152)
#                define GT_PP_NODE_136(p) GT_PP_IIF(p(136), GT_PP_NODE_132, GT_PP_NODE_140)
#                    define GT_PP_NODE_132(p) GT_PP_IIF(p(132), GT_PP_NODE_130, GT_PP_NODE_134)
#                        define GT_PP_NODE_130(p) GT_PP_IIF(p(130), GT_PP_NODE_129, GT_PP_NODE_131)
#                            define GT_PP_NODE_129(p) GT_PP_IIF(p(129), 129, 130)
#                            define GT_PP_NODE_131(p) GT_PP_IIF(p(131), 131, 132)
#                        define GT_PP_NODE_134(p) GT_PP_IIF(p(134), GT_PP_NODE_133, GT_PP_NODE_135)
#                            define GT_PP_NODE_133(p) GT_PP_IIF(p(133), 133, 134)
#                            define GT_PP_NODE_135(p) GT_PP_IIF(p(135), 135, 136)
#                    define GT_PP_NODE_140(p) GT_PP_IIF(p(140), GT_PP_NODE_138, GT_PP_NODE_142)
#                        define GT_PP_NODE_138(p) GT_PP_IIF(p(138), GT_PP_NODE_137, GT_PP_NODE_139)
#                            define GT_PP_NODE_137(p) GT_PP_IIF(p(137), 137, 138)
#                            define GT_PP_NODE_139(p) GT_PP_IIF(p(139), 139, 140)
#                        define GT_PP_NODE_142(p) GT_PP_IIF(p(142), GT_PP_NODE_141, GT_PP_NODE_143)
#                            define GT_PP_NODE_141(p) GT_PP_IIF(p(141), 141, 142)
#                            define GT_PP_NODE_143(p) GT_PP_IIF(p(143), 143, 144)
#                define GT_PP_NODE_152(p) GT_PP_IIF(p(152), GT_PP_NODE_148, GT_PP_NODE_156)
#                    define GT_PP_NODE_148(p) GT_PP_IIF(p(148), GT_PP_NODE_146, GT_PP_NODE_150)
#                        define GT_PP_NODE_146(p) GT_PP_IIF(p(146), GT_PP_NODE_145, GT_PP_NODE_147)
#                            define GT_PP_NODE_145(p) GT_PP_IIF(p(145), 145, 146)
#                            define GT_PP_NODE_147(p) GT_PP_IIF(p(147), 147, 148)
#                        define GT_PP_NODE_150(p) GT_PP_IIF(p(150), GT_PP_NODE_149, GT_PP_NODE_151)
#                            define GT_PP_NODE_149(p) GT_PP_IIF(p(149), 149, 150)
#                            define GT_PP_NODE_151(p) GT_PP_IIF(p(151), 151, 152)
#                    define GT_PP_NODE_156(p) GT_PP_IIF(p(156), GT_PP_NODE_154, GT_PP_NODE_158)
#                        define GT_PP_NODE_154(p) GT_PP_IIF(p(154), GT_PP_NODE_153, GT_PP_NODE_155)
#                            define GT_PP_NODE_153(p) GT_PP_IIF(p(153), 153, 154)
#                            define GT_PP_NODE_155(p) GT_PP_IIF(p(155), 155, 156)
#                        define GT_PP_NODE_158(p) GT_PP_IIF(p(158), GT_PP_NODE_157, GT_PP_NODE_159)
#                            define GT_PP_NODE_157(p) GT_PP_IIF(p(157), 157, 158)
#                            define GT_PP_NODE_159(p) GT_PP_IIF(p(159), 159, 160)
#            define GT_PP_NODE_176(p) GT_PP_IIF(p(176), GT_PP_NODE_168, GT_PP_NODE_184)
#                define GT_PP_NODE_168(p) GT_PP_IIF(p(168), GT_PP_NODE_164, GT_PP_NODE_172)
#                    define GT_PP_NODE_164(p) GT_PP_IIF(p(164), GT_PP_NODE_162, GT_PP_NODE_166)
#                        define GT_PP_NODE_162(p) GT_PP_IIF(p(162), GT_PP_NODE_161, GT_PP_NODE_163)
#                            define GT_PP_NODE_161(p) GT_PP_IIF(p(161), 161, 162)
#                            define GT_PP_NODE_163(p) GT_PP_IIF(p(163), 163, 164)
#                        define GT_PP_NODE_166(p) GT_PP_IIF(p(166), GT_PP_NODE_165, GT_PP_NODE_167)
#                            define GT_PP_NODE_165(p) GT_PP_IIF(p(165), 165, 166)
#                            define GT_PP_NODE_167(p) GT_PP_IIF(p(167), 167, 168)
#                    define GT_PP_NODE_172(p) GT_PP_IIF(p(172), GT_PP_NODE_170, GT_PP_NODE_174)
#                        define GT_PP_NODE_170(p) GT_PP_IIF(p(170), GT_PP_NODE_169, GT_PP_NODE_171)
#                            define GT_PP_NODE_169(p) GT_PP_IIF(p(169), 169, 170)
#                            define GT_PP_NODE_171(p) GT_PP_IIF(p(171), 171, 172)
#                        define GT_PP_NODE_174(p) GT_PP_IIF(p(174), GT_PP_NODE_173, GT_PP_NODE_175)
#                            define GT_PP_NODE_173(p) GT_PP_IIF(p(173), 173, 174)
#                            define GT_PP_NODE_175(p) GT_PP_IIF(p(175), 175, 176)
#                define GT_PP_NODE_184(p) GT_PP_IIF(p(184), GT_PP_NODE_180, GT_PP_NODE_188)
#                    define GT_PP_NODE_180(p) GT_PP_IIF(p(180), GT_PP_NODE_178, GT_PP_NODE_182)
#                        define GT_PP_NODE_178(p) GT_PP_IIF(p(178), GT_PP_NODE_177, GT_PP_NODE_179)
#                            define GT_PP_NODE_177(p) GT_PP_IIF(p(177), 177, 178)
#                            define GT_PP_NODE_179(p) GT_PP_IIF(p(179), 179, 180)
#                        define GT_PP_NODE_182(p) GT_PP_IIF(p(182), GT_PP_NODE_181, GT_PP_NODE_183)
#                            define GT_PP_NODE_181(p) GT_PP_IIF(p(181), 181, 182)
#                            define GT_PP_NODE_183(p) GT_PP_IIF(p(183), 183, 184)
#                    define GT_PP_NODE_188(p) GT_PP_IIF(p(188), GT_PP_NODE_186, GT_PP_NODE_190)
#                        define GT_PP_NODE_186(p) GT_PP_IIF(p(186), GT_PP_NODE_185, GT_PP_NODE_187)
#                            define GT_PP_NODE_185(p) GT_PP_IIF(p(185), 185, 186)
#                            define GT_PP_NODE_187(p) GT_PP_IIF(p(187), 187, 188)
#                        define GT_PP_NODE_190(p) GT_PP_IIF(p(190), GT_PP_NODE_189, GT_PP_NODE_191)
#                            define GT_PP_NODE_189(p) GT_PP_IIF(p(189), 189, 190)
#                            define GT_PP_NODE_191(p) GT_PP_IIF(p(191), 191, 192)
#        define GT_PP_NODE_224(p) GT_PP_IIF(p(224), GT_PP_NODE_208, GT_PP_NODE_240)
#            define GT_PP_NODE_208(p) GT_PP_IIF(p(208), GT_PP_NODE_200, GT_PP_NODE_216)
#                define GT_PP_NODE_200(p) GT_PP_IIF(p(200), GT_PP_NODE_196, GT_PP_NODE_204)
#                    define GT_PP_NODE_196(p) GT_PP_IIF(p(196), GT_PP_NODE_194, GT_PP_NODE_198)
#                        define GT_PP_NODE_194(p) GT_PP_IIF(p(194), GT_PP_NODE_193, GT_PP_NODE_195)
#                            define GT_PP_NODE_193(p) GT_PP_IIF(p(193), 193, 194)
#                            define GT_PP_NODE_195(p) GT_PP_IIF(p(195), 195, 196)
#                        define GT_PP_NODE_198(p) GT_PP_IIF(p(198), GT_PP_NODE_197, GT_PP_NODE_199)
#                            define GT_PP_NODE_197(p) GT_PP_IIF(p(197), 197, 198)
#                            define GT_PP_NODE_199(p) GT_PP_IIF(p(199), 199, 200)
#                    define GT_PP_NODE_204(p) GT_PP_IIF(p(204), GT_PP_NODE_202, GT_PP_NODE_206)
#                        define GT_PP_NODE_202(p) GT_PP_IIF(p(202), GT_PP_NODE_201, GT_PP_NODE_203)
#                            define GT_PP_NODE_201(p) GT_PP_IIF(p(201), 201, 202)
#                            define GT_PP_NODE_203(p) GT_PP_IIF(p(203), 203, 204)
#                        define GT_PP_NODE_206(p) GT_PP_IIF(p(206), GT_PP_NODE_205, GT_PP_NODE_207)
#                            define GT_PP_NODE_205(p) GT_PP_IIF(p(205), 205, 206)
#                            define GT_PP_NODE_207(p) GT_PP_IIF(p(207), 207, 208)
#                define GT_PP_NODE_216(p) GT_PP_IIF(p(216), GT_PP_NODE_212, GT_PP_NODE_220)
#                    define GT_PP_NODE_212(p) GT_PP_IIF(p(212), GT_PP_NODE_210, GT_PP_NODE_214)
#                        define GT_PP_NODE_210(p) GT_PP_IIF(p(210), GT_PP_NODE_209, GT_PP_NODE_211)
#                            define GT_PP_NODE_209(p) GT_PP_IIF(p(209), 209, 210)
#                            define GT_PP_NODE_211(p) GT_PP_IIF(p(211), 211, 212)
#                        define GT_PP_NODE_214(p) GT_PP_IIF(p(214), GT_PP_NODE_213, GT_PP_NODE_215)
#                            define GT_PP_NODE_213(p) GT_PP_IIF(p(213), 213, 214)
#                            define GT_PP_NODE_215(p) GT_PP_IIF(p(215), 215, 216)
#                    define GT_PP_NODE_220(p) GT_PP_IIF(p(220), GT_PP_NODE_218, GT_PP_NODE_222)
#                        define GT_PP_NODE_218(p) GT_PP_IIF(p(218), GT_PP_NODE_217, GT_PP_NODE_219)
#                            define GT_PP_NODE_217(p) GT_PP_IIF(p(217), 217, 218)
#                            define GT_PP_NODE_219(p) GT_PP_IIF(p(219), 219, 220)
#                        define GT_PP_NODE_222(p) GT_PP_IIF(p(222), GT_PP_NODE_221, GT_PP_NODE_223)
#                            define GT_PP_NODE_221(p) GT_PP_IIF(p(221), 221, 222)
#                            define GT_PP_NODE_223(p) GT_PP_IIF(p(223), 223, 224)
#            define GT_PP_NODE_240(p) GT_PP_IIF(p(240), GT_PP_NODE_232, GT_PP_NODE_248)
#                define GT_PP_NODE_232(p) GT_PP_IIF(p(232), GT_PP_NODE_228, GT_PP_NODE_236)
#                    define GT_PP_NODE_228(p) GT_PP_IIF(p(228), GT_PP_NODE_226, GT_PP_NODE_230)
#                        define GT_PP_NODE_226(p) GT_PP_IIF(p(226), GT_PP_NODE_225, GT_PP_NODE_227)
#                            define GT_PP_NODE_225(p) GT_PP_IIF(p(225), 225, 226)
#                            define GT_PP_NODE_227(p) GT_PP_IIF(p(227), 227, 228)
#                        define GT_PP_NODE_230(p) GT_PP_IIF(p(230), GT_PP_NODE_229, GT_PP_NODE_231)
#                            define GT_PP_NODE_229(p) GT_PP_IIF(p(229), 229, 230)
#                            define GT_PP_NODE_231(p) GT_PP_IIF(p(231), 231, 232)
#                    define GT_PP_NODE_236(p) GT_PP_IIF(p(236), GT_PP_NODE_234, GT_PP_NODE_238)
#                        define GT_PP_NODE_234(p) GT_PP_IIF(p(234), GT_PP_NODE_233, GT_PP_NODE_235)
#                            define GT_PP_NODE_233(p) GT_PP_IIF(p(233), 233, 234)
#                            define GT_PP_NODE_235(p) GT_PP_IIF(p(235), 235, 236)
#                        define GT_PP_NODE_238(p) GT_PP_IIF(p(238), GT_PP_NODE_237, GT_PP_NODE_239)
#                            define GT_PP_NODE_237(p) GT_PP_IIF(p(237), 237, 238)
#                            define GT_PP_NODE_239(p) GT_PP_IIF(p(239), 239, 240)
#                define GT_PP_NODE_248(p) GT_PP_IIF(p(248), GT_PP_NODE_244, GT_PP_NODE_252)
#                    define GT_PP_NODE_244(p) GT_PP_IIF(p(244), GT_PP_NODE_242, GT_PP_NODE_246)
#                        define GT_PP_NODE_242(p) GT_PP_IIF(p(242), GT_PP_NODE_241, GT_PP_NODE_243)
#                            define GT_PP_NODE_241(p) GT_PP_IIF(p(241), 241, 242)
#                            define GT_PP_NODE_243(p) GT_PP_IIF(p(243), 243, 244)
#                        define GT_PP_NODE_246(p) GT_PP_IIF(p(246), GT_PP_NODE_245, GT_PP_NODE_247)
#                            define GT_PP_NODE_245(p) GT_PP_IIF(p(245), 245, 246)
#                            define GT_PP_NODE_247(p) GT_PP_IIF(p(247), 247, 248)
#                    define GT_PP_NODE_252(p) GT_PP_IIF(p(252), GT_PP_NODE_250, GT_PP_NODE_254)
#                        define GT_PP_NODE_250(p) GT_PP_IIF(p(250), GT_PP_NODE_249, GT_PP_NODE_251)
#                            define GT_PP_NODE_249(p) GT_PP_IIF(p(249), 249, 250)
#                            define GT_PP_NODE_251(p) GT_PP_IIF(p(251), 251, 252)
#                        define GT_PP_NODE_254(p) GT_PP_IIF(p(254), GT_PP_NODE_253, GT_PP_NODE_255)
#                            define GT_PP_NODE_253(p) GT_PP_IIF(p(253), 253, 254)
#                            define GT_PP_NODE_255(p) GT_PP_IIF(p(255), 255, 256)
#
# endif
#
# endif
#
# else
#
# if GT_PP_CONFIG_FLAGS() & GT_PP_CONFIG_DMC()
#     include <gridtools/preprocessor/detail/dmc/auto_rec.hpp>
# else
#
# ifndef GT_PREPROCESSOR_DETAIL_AUTO_REC_HPP
# define GT_PREPROCESSOR_DETAIL_AUTO_REC_HPP
#
# /* GT_PP_AUTO_REC */
#
# include <gridtools/preprocessor/control/iif.hpp>
#
# define GT_PP_AUTO_REC(pred, n) GT_PP_NODE_ENTRY_ ## n(pred)
#
# include <gridtools/preprocessor/config/limits.hpp>
#
# if GT_PP_LIMIT_MAG == 256
# include <gridtools/preprocessor/detail/limits/auto_rec_256.hpp>
# elif GT_PP_LIMIT_MAG == 512
# include <gridtools/preprocessor/detail/limits/auto_rec_256.hpp>
# include <gridtools/preprocessor/detail/limits/auto_rec_512.hpp>
# elif GT_PP_LIMIT_MAG == 1024
# include <gridtools/preprocessor/detail/limits/auto_rec_256.hpp>
# include <gridtools/preprocessor/detail/limits/auto_rec_512.hpp>
# include <gridtools/preprocessor/detail/limits/auto_rec_1024.hpp>
# else
# error Incorrect value for the GT_PP_LIMIT_MAG limit
# endif
#
# endif
#
# endif
#
# endif
